/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2012 Smithsonian Astrophysical Observatory
 *
 * This file is part of blur
 *
 * blur is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * -->8-->8-->8-->8-- */

#ifndef MAIN_H
#define MAIN_H

#define NAME_LENGTH 255

typedef enum
{
  FUNC_gauss1D_fwhm,
  FUNC_gauss1D_dev,
  FUNC_gauss1D,
  FUNC_rect_uni
} BlurFunc;

typedef struct
{
  char input[NAME_LENGTH+1];
  char output[NAME_LENGTH+1];

  long seed1, seed2, block;
  BlurFunc blurfunc;

  int version;
  int help;

  /* general multiplicative factor */
  double scale;

  /* 1D gauss */
  float std_dev;

  /* uniform rectangle */
  float half_width, half_height;

} Common;


extern char debug[ 255 +1];
extern Common c;

void gparam(int argc, char *argv[]);
void process(void);

#endif /* !MAIN_H */
